- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sbuild::chroot_directory Class Reference

A chroot located in the filesystem. More...

`#include <sbuild-chroot-directory.h>`

Inheritance diagram for sbuild::chroot_directory:

[legend]
Collaboration diagram for sbuild::chroot_directory:

[legend]
List of all members.

## Public Member Functions
virtual | ~chroot_directory ()
| The destructor.
virtual chroot::ptr | clone () const
| Copy the chroot.
virtual std::string const & | get_location () const
| Get the directory location of the chroot.
virtual void | set_location (std::string const &location)
| Set the directory location of the chroot.
virtual std::string | get_path () const
| Get the path to the chroot.
virtual std::string const & | get_chroot_type () const
| Get the type of the chroot.
virtual session_flags | get_session_flags () const
| Get the session flags of the chroot.
## Protected Member Functions
| chroot_directory ()
| The constructor.
virtual void | setup_lock (chroot::setup_type type, bool lock, int status)
| Unlock a chroot during setup.
virtual void | get_details (format_detail &detail) const
| Get detailed information about the chroot for output.
virtual void | get_keyfile (keyfile &keyfile) const
| Copy the chroot properties into a keyfile.
virtual void | set_keyfile (keyfile const &keyfile)
| Set the chroot properties from a keyfile.
## Friends
class | chroot

## Detailed Description

A chroot located in the filesystem.

## Constructor & Destructor Documentation

chroot_directory::chroot_directory | ( |  | ) | `[protected]`

The constructor.

chroot_directory::~chroot_directory | ( |  | ) | `[virtual]`

The destructor.

## Member Function Documentation

sbuild::chroot::ptr chroot_directory::clone | ( |  | ) | const`[virtual]`

Copy the chroot.

This is a virtual copy constructor.

Returns:
  a shared_ptr to the new copy of the chroot.

Implements sbuild::chroot.

Reimplemented in sbuild::chroot_plain.

std::string const & chroot_directory::get_chroot_type | ( |  | ) | const`[virtual]`

Get the type of the chroot.

Returns:
  the chroot type.

Implements sbuild::chroot.

Reimplemented in sbuild::chroot_plain.

void chroot_directory::get_details | ( | format_detail & | detail | ) | const`[protected, virtual]`

Get detailed information about the chroot for output.

Parameters:

  | detail | the details to output to.

Reimplemented from sbuild::chroot.

void chroot_directory::get_keyfile | ( | keyfile & | keyfile | ) | const`[protected, virtual]`

Copy the chroot properties into a keyfile.

The keyfile group with the name of the chroot will be set; if it already exists, it will be removed before setting it.

Parameters:

  | keyfile | the keyfile to use.

Reimplemented from sbuild::chroot.

std::string const & chroot_directory::get_location | ( |  | ) | const`[virtual]`

Get the directory location of the chroot.

Returns:
  the location.

Reimplemented from sbuild::chroot.

std::string chroot_directory::get_path | ( |  | ) | const`[virtual]`

Get the path to the chroot.

This is the absolute path to the root of the chroot, and is typically the same as the mount location and location concatenated together, but is overridden by the chroot type if required.

Returns:
  the path.

Reimplemented from sbuild::chroot.

sbuild::chroot::session_flags chroot_directory::get_session_flags | ( |  | ) | const`[virtual]`

Get the session flags of the chroot.

These determine how the Session controlling the chroot will operate.

Returns:
  the session flags.

Implements sbuild::chroot.

void chroot_directory::set_keyfile | ( | keyfile const & | keyfile | ) | `[protected, virtual]`

Set the chroot properties from a keyfile.

The chroot name must have previously been set, so that the correct keyfile group may be determined.

Parameters:

  | keyfile | the keyfile to get the properties from.

Reimplemented from sbuild::chroot.

void chroot_directory::set_location | ( | std::string const & | location | ) | `[virtual]`

Set the directory location of the chroot.

Parameters:

  | location | the location.

Reimplemented from sbuild::chroot.

void chroot_directory::setup_lock | ( | chroot::setup_type | type,
|  | bool | lock,
|  | int | status |
| ) |  |  | `[protected, virtual]`

Unlock a chroot during setup.

The locking technique (if any) may vary depending upon the chroot type and setup stage. For example, during creation of an LVM snapshot a block device might require locking, but afterwards this will change to the new block device.

An error will be thrown on failure.

Parameters:

  | type | the type of setup being performed
  | lock | true to lock, false to unlock
  | status | the exit status of the setup commands (0 for success, nonzero for failure).

Implements sbuild::chroot.

## Friends And Related Function Documentation

friend class chroot`[friend]`

Reimplemented in sbuild::chroot_plain.

The documentation for this class was generated from the following files:

- sbuild/sbuild-chroot-directory.h
- sbuild/sbuild-chroot-directory.cc